/* LED counter GNOME panel applet
 * Insprired by Sixtyfour bit counter by Tim Gerla
 * and xled by Jan Schoenepauck <schoenep@uni-wuppertal.de>
 * and Joachim Gassen <gassen@uni-muenster.de>"
 *
 * By Uwe Steinmann <Uwe.Steinmann@fernuni-hagen.de>
 *
 * Enjoy.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or 
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License  
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __LEDCOUNT_H__
#define __LEDCOUNT_H__

#include "gtkdisplay.h"

/* now defined in Makefile
#define MAX_DISPLAYS 10
*/
#define	BUTTON_HEIGHT	(10)
#define DISPLAY_WIDTH 51
#define	DISPLAY_HEIGHT 33

#define MODE_MAILBOX 1
#define MODE_IMAP    2
#define MODE_COMMAND 3
#define MODE_VBOX    4
typedef struct _DISP_INFO {
	void *parent;         // Pointer to Counter this display belongs to
	int number;           // number of the display
	GtkWidget *frame;     // Container for display, frame and button
	GtkWidget *display;   // Just the display
	GtkWidget *container; // Container for display, frame and button
	GtkWidget *label;     // Just the label on the button
	GtkWidget *button;    // Just the label on the button
	GtkWidget *tip;       // Tooltip
	guint digits;         // Number of digits
	guint autodigits;     // 1 if autoranging is on
	guint leading_zeros;  // 1 if leading zeors are on
	DISPTYPE disptype;    // Alpha or 7-Segment
	char *mailbox_file;   // the mailbox
	char *imap_server;		// IMAP Server
	char *imap_username;	// IMAP Username
	char *imap_password;	// IMAP Password
	int show_all_messages;// 1 if all messages should be shown
	int count_mode;       // 1=count mail, 0=frontend mode or vbox
	int front_end_mode;   // 1=run count command 0=vbox (always 0)
	char *backend_command;// count command
	char *exec_command;   // execute if command button clicked
	int exec_button;      // 1=show command button
	char *title;          // Title shown in command button
	gint timeout;         // timeout
	int updatetime;       // time in ms between updates
	int preset;           // preset value of counter
	int lastcount;        // last time counted
	guint indicate_counting;// show if counting runs
	time_t lasttime;      // time of last mail check
} DISP_INFO;

typedef struct _CountData {
	GtkWidget *app;       // Das Applet
	GtkWidget *counter;
	GtkWidget *globalbox;
	GtkWidget *pb;        // Property box
	GtkWidget *display_clist;	// Liste in der Property box
	GtkWidget *try_button, *delete_button, *new_button;
	GNOME_Panel_OrientType orient;
	int height, width;
	int spacing;
	GdkColor on, off, over;
	gchar con_s[32], coff_s[32], cover_s[32];
	GList *displist;      // List of Displays
	int displays;         // number of displays
	int current_number;
} CountData;
#endif
