/* LED counter GNOME panel applet
 * Insprired by Sixtyfour bit counter by Tim Gerla
 * and xled by Jan Schoenepauck <schoenep@uni-wuppertal.de>
 * and Joachim Gassen <gassen@uni-muenster.de>"
 *
 * By Uwe Steinmann <Uwe.Steinmann@fernuni-hagen.de>
 *
 * Enjoy.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or 
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License  
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <gnome.h>
#include <applet-widget.h>
#include "gtkdisplay.h"
#include "ledcount.h"
#include "disp_manage.h"

static int count_mode;
extern void count_timer(DISP_INFO *data);
extern void add_exec_button(DISP_INFO *disp_info);
extern void remove_exec_button(DISP_INFO *disp_info);
extern void change_spacing(CountData *cd, int space);
extern void add_new_display(CountData *cd, GtkWidget *table, DISP_INFO *disp_info);
extern void save_config(gchar *privcfgpath, CountData *cd);


static void fill_display_prefs(CountData *cd, DISP_INFO *disp_info);
static void populate_list(CountData *cd);

static void toggle_autorange(GtkWidget *widget, void *data)
{
	char buffer[50];
	CountData *cd = data;

	GtkWidget *w;
	GnomePropertyBox *box = GNOME_PROPERTY_BOX (cd->pb);
	sprintf(buffer, "digits");
	w = gtk_object_get_data(GTK_OBJECT(box), buffer);
	if(GTK_TOGGLE_BUTTON(widget)->active) {
		gtk_widget_set_sensitive(GTK_WIDGET(w), FALSE);
	} else {
		gtk_widget_set_sensitive(GTK_WIDGET(w), TRUE);
	}
	gnome_property_box_changed(GNOME_PROPERTY_BOX(cd->pb));
	gtk_widget_set_sensitive (cd->try_button, TRUE);
}

static void toggle_countmode(GtkWidget *widget, void *data)
{
	char buffer[50];
	CountData *cd = data;

	GtkWidget *w, *w1, *w2;
	GnomePropertyBox *box = GNOME_PROPERTY_BOX (cd->pb);
	sprintf(buffer, "mailbox");
	w = gtk_object_get_data(GTK_OBJECT(box), buffer);
	sprintf(buffer, "countmodeframe");
	w1 = gtk_object_get_data(GTK_OBJECT(box), buffer);
	sprintf(buffer, "backend");
	w2 = gtk_object_get_data(GTK_OBJECT(box), buffer);
	if(GTK_TOGGLE_BUTTON(widget)->active) {
		gtk_widget_set_sensitive(GTK_WIDGET(w), TRUE);
		gtk_widget_set_sensitive(GTK_WIDGET(w1), TRUE);
		gtk_widget_set_sensitive(GTK_WIDGET(w2), FALSE);
	} else {
		gtk_widget_set_sensitive(GTK_WIDGET(w), FALSE);
		gtk_widget_set_sensitive(GTK_WIDGET(w1), FALSE);
		gtk_widget_set_sensitive(GTK_WIDGET(w2), TRUE);
	}
	gnome_property_box_changed(GNOME_PROPERTY_BOX(cd->pb));
	gtk_widget_set_sensitive (cd->try_button, TRUE);
}

static void set_mailbox_mode(GtkWidget *widget, void *data)
{
	char buffer[50];
	CountData *cd = data;

	GtkWidget *w, *w1, *w2;
	GnomePropertyBox *box = GNOME_PROPERTY_BOX (cd->pb);
	sprintf(buffer, "mailboxbox");
	w = gtk_object_get_data(GTK_OBJECT(box), buffer);
	gtk_widget_set_sensitive(GTK_WIDGET(w), TRUE);
	sprintf(buffer, "countmodeframe");
	w1 = gtk_object_get_data(GTK_OBJECT(box), buffer);
	gtk_widget_set_sensitive(GTK_WIDGET(w1), TRUE);
	sprintf(buffer, "backend");
	w2 = gtk_object_get_data(GTK_OBJECT(box), buffer);
	gtk_widget_set_sensitive(GTK_WIDGET(w2), FALSE);
	sprintf(buffer, "imapserver");
	w2 = gtk_object_get_data(GTK_OBJECT(box), buffer);
	gtk_widget_set_sensitive(GTK_WIDGET(w2), FALSE);
	sprintf(buffer, "imapusername");
	w2 = gtk_object_get_data(GTK_OBJECT(box), buffer);
	gtk_widget_set_sensitive(GTK_WIDGET(w2), FALSE);
	sprintf(buffer, "imappassname");
	w2 = gtk_object_get_data(GTK_OBJECT(box), buffer);
	gtk_widget_set_sensitive(GTK_WIDGET(w2), FALSE);

	gnome_property_box_changed(GNOME_PROPERTY_BOX(cd->pb));
	gtk_widget_set_sensitive (cd->try_button, TRUE);
	count_mode = MODE_MAILBOX;
}

static void set_imap_mode(GtkWidget *widget, void *data)
{
	char buffer[50];
	CountData *cd = data;

	GtkWidget *w, *w1, *w2;
	GnomePropertyBox *box = GNOME_PROPERTY_BOX (cd->pb);
	sprintf(buffer, "mailboxbox");
	w = gtk_object_get_data(GTK_OBJECT(box), buffer);
	gtk_widget_set_sensitive(GTK_WIDGET(w), TRUE);
	sprintf(buffer, "countmodeframe");
	w1 = gtk_object_get_data(GTK_OBJECT(box), buffer);
	gtk_widget_set_sensitive(GTK_WIDGET(w1), FALSE);
	sprintf(buffer, "backend");
	w2 = gtk_object_get_data(GTK_OBJECT(box), buffer);
	gtk_widget_set_sensitive(GTK_WIDGET(w2), FALSE);
	sprintf(buffer, "imapserver");
	w2 = gtk_object_get_data(GTK_OBJECT(box), buffer);
	gtk_widget_set_sensitive(GTK_WIDGET(w2), TRUE);
	sprintf(buffer, "imapusername");
	w2 = gtk_object_get_data(GTK_OBJECT(box), buffer);
	gtk_widget_set_sensitive(GTK_WIDGET(w2), TRUE);
	sprintf(buffer, "imappassname");
	w2 = gtk_object_get_data(GTK_OBJECT(box), buffer);
	gtk_widget_set_sensitive(GTK_WIDGET(w2), TRUE);

	gnome_property_box_changed(GNOME_PROPERTY_BOX(cd->pb));
	gtk_widget_set_sensitive (cd->try_button, TRUE);
	count_mode = MODE_IMAP;
}

static void set_command_mode(GtkWidget *widget, void *data)
{
	char buffer[50];
	CountData *cd = data;

	GtkWidget *w, *w1, *w2;
	GnomePropertyBox *box = GNOME_PROPERTY_BOX (cd->pb);
	sprintf(buffer, "mailboxbox");
	w = gtk_object_get_data(GTK_OBJECT(box), buffer);
	gtk_widget_set_sensitive(GTK_WIDGET(w), FALSE);
	sprintf(buffer, "countmodeframe");
	w1 = gtk_object_get_data(GTK_OBJECT(box), buffer);
	gtk_widget_set_sensitive(GTK_WIDGET(w1), FALSE);
	sprintf(buffer, "backend");
	w2 = gtk_object_get_data(GTK_OBJECT(box), buffer);
	gtk_widget_set_sensitive(GTK_WIDGET(w2), TRUE);
	sprintf(buffer, "imapserver");
	w2 = gtk_object_get_data(GTK_OBJECT(box), buffer);
	gtk_widget_set_sensitive(GTK_WIDGET(w2), FALSE);
	sprintf(buffer, "imapusername");
	w2 = gtk_object_get_data(GTK_OBJECT(box), buffer);
	gtk_widget_set_sensitive(GTK_WIDGET(w2), FALSE);
	sprintf(buffer, "imappassname");
	w2 = gtk_object_get_data(GTK_OBJECT(box), buffer);
	gtk_widget_set_sensitive(GTK_WIDGET(w2), FALSE);

	gnome_property_box_changed(GNOME_PROPERTY_BOX(cd->pb));
	gtk_widget_set_sensitive (cd->try_button, TRUE);
	count_mode = MODE_COMMAND;
}

static void destroy_cb(GtkWidget *pb, gpointer data)
{
	CountData *cd = data;
	gtk_widget_destroy(cd->pb);
	cd->pb = NULL;
}

static void apply_cb(GtkObject *pb, gint page, gpointer data)
{
	guint8 r1, g1, b1, r2, g2, b2;
	char *buf;
	DISP_INFO *disp_info;
	CountData *cd = data;

	GnomeColorPicker *con = gtk_object_get_data(GTK_OBJECT(cd->pb), "con");
	GnomeColorPicker *coff= gtk_object_get_data(GTK_OBJECT(cd->pb), "coff");
	GnomeColorPicker *cover= gtk_object_get_data(GTK_OBJECT(cd->pb), "cover");
	GtkWidget *width_s = gtk_object_get_data(GTK_OBJECT(cd->pb),"width");
	GtkWidget *height_s = gtk_object_get_data(GTK_OBJECT(cd->pb),"height");
	GtkWidget *spacing_s = gtk_object_get_data(GTK_OBJECT(cd->pb), "spacing");

	/* Do not make the changes on page basis, but for all pages */
	if(page != -1)
		return;

	buf = gtk_entry_get_text(GTK_ENTRY(height_s));
	sscanf(buf, "%d", &(cd->height));
	buf = gtk_entry_get_text(GTK_ENTRY(width_s));
	sscanf(buf, "%d", &(cd->width));
/*	buf = gtk_entry_get_text(GTK_ENTRY(displays_s));
	sscanf(buf, "%d", &new_displays); */
	buf = gtk_entry_get_text(GTK_ENTRY(spacing_s));
	sscanf(buf, "%d", &(cd->spacing));

	/**** Set colors ****/
	gnome_color_picker_get_i8(con,  &r1, &g1, &b1, NULL);
	g_snprintf(cd->con_s, 31, "#%02X%02X%02X", r1, g1, b1);

	gnome_color_picker_get_i8(coff, &r2, &g2, &b2, NULL);
	g_snprintf(cd->coff_s, 31, "#%02X%02X%02X", r2, g2, b2);
	
	gnome_color_picker_get_i8(cover, &r2, &g2, &b2, NULL);
	g_snprintf(cd->cover_s, 31, "#%02X%02X%02X", r2, g2, b2);

	gdk_color_parse(cd->con_s, &(cd->on));
	gdk_color_parse(cd->coff_s, &(cd->off));
	gdk_color_parse(cd->cover_s, &(cd->over));

	disp_info = get_first_disp(cd->displist);
	while(disp_info) {
		gtk_display_set_colors(GTK_DISPLAY(disp_info->display), &(cd->on), &(cd->off), &(cd->over));
		gtk_widget_set_usize((GTK_WIDGET(disp_info->display)),
		  gtk_display_get_digits(GTK_DISPLAY(disp_info->display))*cd->width,
		  cd->height);
		count_timer(disp_info);
		disp_info = get_next_disp(cd->displist, disp_info);
	}

	/**** Update all counters ****/
//	count_timer(NULL);

	/**** Change spacing ****/
	change_spacing(cd, cd->spacing);

	save_config(APPLET_WIDGET(cd->app)->privcfgpath, cd);
}

static void
changed_cb(GtkWidget *w, gpointer data)
{	
	CountData *cd = data;
	gnome_property_box_changed(GNOME_PROPERTY_BOX(cd->pb));
	gtk_widget_set_sensitive (cd->try_button, TRUE);
}

static void
col_changed_cb(GtkWidget *w, guint arg1, guint arg2,
          guint arg3, guint arg4, gpointer data)
{	
	CountData *cd = data;
	gnome_property_box_changed(GNOME_PROPERTY_BOX(cd->pb));
	gtk_widget_set_sensitive (cd->try_button, TRUE);
}

static void
select_display_clist(GtkWidget *w, gint row, gint column, GdkEventButton *event, gpointer data)
{	
	int number;
	DISP_INFO *disp_info;
	CountData *cd = data;
	number = (int) gtk_clist_get_row_data(GTK_CLIST(w),row);
	if(NULL == (disp_info = get_disp(cd->displist, number)))
		return;
	fill_display_prefs(cd, disp_info);
  cd->current_number = number;
}

static void
update_display(CountData *cd, DISP_INFO *disp_info)
{
	if(disp_info->exec_button)
		gtk_label_set(GTK_LABEL(disp_info->label), disp_info->title);
	gtk_display_set_autorange(GTK_DISPLAY(disp_info->display),
	                          disp_info->autodigits);
	gtk_display_set_displaytype(GTK_DISPLAY(disp_info->display),
	                            disp_info->disptype);
	gtk_display_set_leadingzeros(GTK_DISPLAY(disp_info->display),
	                             disp_info->leading_zeros);
	if(disp_info->autodigits == 0)
		gtk_display_set_digits(GTK_DISPLAY(disp_info->display),
		                       disp_info->digits);
	gtk_widget_set_usize((GTK_WIDGET(disp_info->display)),
	  gtk_display_get_digits(GTK_DISPLAY(disp_info->display))*cd->width,
	  cd->height);
	gtk_tooltips_set_tip(GTK_TOOLTIPS(disp_info->tip),
	                     disp_info->button,
	                     disp_info->title, NULL);
	count_timer(disp_info);
}

static void
up_button_callback(GtkWidget *w, gpointer *d)
{	
	DISP_INFO *disp_info, *disp_prev_info;
	CountData *cd = (CountData *) d;

	if(NULL == (disp_info = get_disp(cd->displist, cd->current_number)))
  	return;
	if(NULL == (disp_prev_info = get_prev_disp(cd->displist, disp_info)))
		return;

	switch_disp_data(disp_prev_info, disp_info);
	gtk_clist_clear(GTK_CLIST(cd->display_clist));
	populate_list(cd);
	gtk_clist_select_row(GTK_CLIST(cd->display_clist), 0, 1);
	if(disp_prev_info->exec_button != disp_info->exec_button) {
		if(disp_prev_info->exec_button) {
			add_exec_button(disp_prev_info);
			remove_exec_button(disp_info);
		} else {
			add_exec_button(disp_info);
			remove_exec_button(disp_prev_info);
		}
	}
	update_display(cd, disp_prev_info);
	update_display(cd, disp_info);
}

static void
down_button_callback(GtkWidget *w, gpointer *d)
{	
	DISP_INFO *disp_info, *disp_next_info;
	CountData *cd = (CountData *) d;

	if(NULL == (disp_info = get_disp(cd->displist, cd->current_number)))
  	return;
	if(NULL == (disp_next_info = get_next_disp(cd->displist, disp_info)))
		return;

	switch_disp_data(disp_next_info, disp_info);
	gtk_clist_clear(GTK_CLIST(cd->display_clist));
	populate_list(cd);
	if(disp_next_info->exec_button != disp_info->exec_button) {
		if(disp_next_info->exec_button) {
			add_exec_button(disp_next_info);
			remove_exec_button(disp_info);
		} else {
			add_exec_button(disp_info);
			remove_exec_button(disp_next_info);
		}
	}
	update_display(cd, disp_next_info);
	update_display(cd, disp_info);
}

static void
try_button_callback(GtkWidget *w, gpointer *d)
{	
	GtkWidget *mailbox_s;
	DISP_INFO *disp_info;
	int itmp;
	char *buf;
	CountData *cd = (CountData *) d;

	if(NULL == (disp_info = get_disp(cd->displist, cd->current_number)))
		return;

	/**** Mailbox ****/
	mailbox_s = gtk_object_get_data(GTK_OBJECT(cd->pb), "mailbox");
	if(disp_info->mailbox_file) {
		free(disp_info->mailbox_file);
		disp_info->mailbox_file = NULL;
	}
	disp_info->mailbox_file = strdup(gtk_entry_get_text(GTK_ENTRY(mailbox_s)));

	/**** Execute if button is pressed ****/
	mailbox_s = gtk_object_get_data(GTK_OBJECT(cd->pb), "exec");
	if(disp_info->exec_command) {
		free(disp_info->exec_command);
	}
	disp_info->exec_command = strdup(gtk_entry_get_text(GTK_ENTRY(mailbox_s)));

	/**** Title ****/
	mailbox_s = gtk_object_get_data(GTK_OBJECT(cd->pb), "title");
	if(disp_info->title) {
		free(disp_info->title);
	}
	disp_info->title = strdup(gtk_entry_get_text(GTK_ENTRY(mailbox_s)));
	if(disp_info->exec_button)
		gtk_label_set(GTK_LABEL(disp_info->label), disp_info->title);
	if(disp_info->tip)
		gtk_tooltips_set_tip(GTK_TOOLTIPS(disp_info->tip), disp_info->button, disp_info->title, NULL);

	/**** Command to count something ****/
	mailbox_s = gtk_object_get_data(GTK_OBJECT(cd->pb), "backend");
	if(disp_info->backend_command) {
		free(disp_info->backend_command);
	}
	disp_info->backend_command = strdup(gtk_entry_get_text(GTK_ENTRY(mailbox_s)));

	/**** IMAP Server ****/
	mailbox_s = gtk_object_get_data(GTK_OBJECT(cd->pb), "imapserver");
	if(disp_info->imap_server) {
		free(disp_info->imap_server);
	}
	disp_info->imap_server = strdup(gtk_entry_get_text(GTK_ENTRY(mailbox_s)));

	/**** IMAP Username ****/
	mailbox_s = gtk_object_get_data(GTK_OBJECT(cd->pb), "imapusername");
	if(disp_info->imap_username) {
		free(disp_info->imap_username);
	}
	disp_info->imap_username = strdup(gtk_entry_get_text(GTK_ENTRY(mailbox_s)));

	/**** IMAP Password ****/
	mailbox_s = gtk_object_get_data(GTK_OBJECT(cd->pb), "imappassname");
	if(disp_info->imap_password) {
		free(disp_info->imap_password);
	}
	disp_info->imap_password = strdup(gtk_entry_get_text(GTK_ENTRY(mailbox_s)));

	/**** Counter mode (Mailbox/IMAP/POP3/Kommand) ****/
	disp_info->count_mode = count_mode;

	/**** Show unread/all messages ****/
	mailbox_s = gtk_object_get_data(GTK_OBJECT(cd->pb), "unreadmessages");
	disp_info->show_all_messages = GTK_TOGGLE_BUTTON(mailbox_s)->active ? 0 : 1;

	/**** Autorange on/off ****/
	mailbox_s = gtk_object_get_data(GTK_OBJECT(cd->pb), "autorange");
	disp_info->autodigits = GTK_TOGGLE_BUTTON(mailbox_s)->active ? 1 : 0;
	gtk_display_set_autorange(GTK_DISPLAY(disp_info->display), disp_info->autodigits);

	/**** button on/off ****/
	mailbox_s = gtk_object_get_data(GTK_OBJECT(cd->pb), "execbutton");
	itmp = GTK_TOGGLE_BUTTON(mailbox_s)->active ? 1 : 0;
	if(itmp != disp_info->exec_button) {
		if(itmp)
			add_exec_button(disp_info);
		else
			remove_exec_button(disp_info);
		disp_info->exec_button = itmp;
	}

	/**** alpha numeric/7-segment ****/
	mailbox_s = gtk_object_get_data(GTK_OBJECT(cd->pb), "alphanumeric");
	disp_info->disptype = GTK_TOGGLE_BUTTON(mailbox_s)->active ? DispSevenSegment : DispAlphaNumeric;
	gtk_display_set_displaytype(GTK_DISPLAY(disp_info->display), disp_info->disptype);

	/**** leading zeros ****/
	mailbox_s = gtk_object_get_data(GTK_OBJECT(cd->pb), "leadingzeros");
	disp_info->leading_zeros = GTK_TOGGLE_BUTTON(mailbox_s)->active ? 1 : 0;
	gtk_display_set_leadingzeros(GTK_DISPLAY(disp_info->display), disp_info->leading_zeros);

	/**** indicate counting ****/
	mailbox_s = gtk_object_get_data(GTK_OBJECT(cd->pb), "indicatecounting");
	disp_info->indicate_counting = GTK_TOGGLE_BUTTON(mailbox_s)->active ? 1 : 0;

	/**** Number of digits *****/
	mailbox_s = gtk_object_get_data(GTK_OBJECT(cd->pb), "digits");
	buf = gtk_entry_get_text(GTK_ENTRY(mailbox_s));
	sscanf(buf, "%d", &disp_info->digits);
	if(disp_info->autodigits == 0) {
		gtk_display_set_digits(GTK_DISPLAY(disp_info->display), disp_info->digits);
	}

	/**** Renew timeout for this display *****/
	mailbox_s = gtk_object_get_data(GTK_OBJECT(cd->pb), "update");
	buf = gtk_entry_get_text(GTK_ENTRY(mailbox_s));
	sscanf(buf, "%d", &disp_info->updatetime);
	gtk_timeout_remove(disp_info->timeout);
	disp_info->timeout = gtk_timeout_add(disp_info->updatetime, (GtkFunction)count_timer, (void *) disp_info);

	/**** Preset for this display *****/
	mailbox_s = gtk_object_get_data(GTK_OBJECT(cd->pb), "preset");
	buf = gtk_entry_get_text(GTK_ENTRY(mailbox_s));
	sscanf(buf, "%d", &disp_info->preset);

	/**** Correct size of display depending of button ****/
	if(disp_info->exec_button)
		gtk_widget_set_usize(disp_info->display,
		  cd->width*gtk_display_get_digits(GTK_DISPLAY(disp_info->display)),
		  cd->height);
	else
		gtk_widget_set_usize(disp_info->display,
		  cd->width*gtk_display_get_digits(GTK_DISPLAY(disp_info->display)),
		  cd->height+BUTTON_HEIGHT);

	/**** Update all counters ****/
	count_timer(disp_info);

	gtk_widget_set_sensitive (cd->try_button, FALSE);
}

static void
delete_button_callback(GtkWidget *w, gpointer *d)
{	
	DISP_INFO *disp_info;
	gint row;
	CountData *cd = (CountData *) d;

	if(NULL == (disp_info = get_disp(cd->displist, cd->current_number)))
		return;

	gtk_timeout_remove(disp_info->timeout);
	gtk_widget_destroy(disp_info->frame);
	row = gtk_clist_find_row_from_data(GTK_CLIST(cd->display_clist), (gpointer) cd->current_number);
	gtk_clist_remove(GTK_CLIST(cd->display_clist), row);
	gtk_clist_select_row(GTK_CLIST(cd->display_clist), 0, 1);
	cd->displist = remove_disp(cd->displist, disp_info);
	disp_info = get_first_disp(cd->displist);
	fill_display_prefs(cd, disp_info);
	cd->current_number = disp_info->number;
//	cd->displays = get_number_of_disp(cd->displist);
}

static void
new_button_callback(GtkWidget *w, gpointer *d) {	
	DISP_INFO *disp_info;
	CountData *cd = (CountData *) d;
	
	disp_info = get_disp(cd->displist, cd->current_number);
fprintf(stderr, "current_number = %d\n", cd->current_number);
	if(NULL != (disp_info = add_disp(&(cd->displist), disp_info))) {
		gchar *pcs[2];
		char buffer[4];
		gint row;

		disp_info->parent = cd;
		disp_info->number = ++cd->displays;
		add_new_display(cd, cd->counter, disp_info);
		gtk_widget_show_all(cd->counter);
		sprintf(buffer, "%d", disp_info->number);
		pcs[0] = strdup(buffer);
		pcs[1] = strdup(disp_info->title);
		row = gtk_clist_append(GTK_CLIST(cd->display_clist), pcs);
		gtk_clist_set_row_data(GTK_CLIST(cd->display_clist), row, (void *) disp_info->number);
		gtk_clist_select_row(GTK_CLIST(cd->display_clist), row, 1);
		cd->current_number = disp_info->number;
	}
	gtk_widget_set_sensitive (cd->try_button, TRUE);
}

static void
fill_display_prefs(CountData *cd, DISP_INFO *disp_info) {
	char buffer[40];
	GtkWidget *mailbox_s, *t_button, *b_button;

	/* set current count_mode in static var. We need this because
	   I don't know how to find what the current selection in the
	   option menu is. So we keep a separate var. */
	count_mode = disp_info->count_mode;

	/**** Mailbox ****/
	mailbox_s = gtk_object_get_data(GTK_OBJECT(cd->pb), "mailbox");
	gtk_entry_set_text(GTK_ENTRY(mailbox_s), (gchar *) disp_info->mailbox_file);
	gtk_widget_set_sensitive(mailbox_s, disp_info->count_mode == MODE_COMMAND ? FALSE : TRUE);

	/**** Execute if button is pressed ****/
	mailbox_s = gtk_object_get_data(GTK_OBJECT(cd->pb), "exec");
	gtk_entry_set_text(GTK_ENTRY(mailbox_s), (gchar *) disp_info->exec_command);

	/**** Title ****/
	mailbox_s = gtk_object_get_data(GTK_OBJECT(cd->pb), "title");
	gtk_entry_set_text(GTK_ENTRY(mailbox_s), (gchar *) disp_info->title);

	/**** Command to count something ****/
	mailbox_s = gtk_object_get_data(GTK_OBJECT(cd->pb), "backend");
	gtk_entry_set_text(GTK_ENTRY(mailbox_s), (gchar *) disp_info->backend_command);
	gtk_widget_set_sensitive(mailbox_s, disp_info->count_mode == MODE_COMMAND ? TRUE : FALSE);

	/**** IMAP server ****/
	mailbox_s = gtk_object_get_data(GTK_OBJECT(cd->pb), "imapserver");
	gtk_entry_set_text(GTK_ENTRY(mailbox_s), (gchar *) disp_info->imap_server);
	gtk_widget_set_sensitive(mailbox_s, disp_info->count_mode == MODE_IMAP ? TRUE : FALSE);

	/**** IMAP username ****/
	mailbox_s = gtk_object_get_data(GTK_OBJECT(cd->pb), "imapusername");
	gtk_entry_set_text(GTK_ENTRY(mailbox_s), (gchar *) disp_info->imap_username);
	gtk_widget_set_sensitive(mailbox_s, disp_info->count_mode == MODE_IMAP ? TRUE : FALSE);

	/**** IMAP password ****/
	mailbox_s = gtk_object_get_data(GTK_OBJECT(cd->pb), "imappassname");
	gtk_entry_set_text(GTK_ENTRY(mailbox_s), (gchar *) disp_info->imap_password);
	gtk_widget_set_sensitive(mailbox_s, disp_info->count_mode == MODE_IMAP ? TRUE : FALSE);

	/**** Counter mode (Mail/Kommand) ****/
	mailbox_s = gtk_object_get_data(GTK_OBJECT(cd->pb), "countwhat");
	gtk_option_menu_set_history (GTK_OPTION_MENU (mailbox_s), disp_info->count_mode-1);

	/**** Show unread/all messages ****/
	mailbox_s = gtk_object_get_data(GTK_OBJECT(cd->pb), "countmodeframe");
	gtk_widget_set_sensitive(mailbox_s, disp_info->count_mode == MODE_MAILBOX ? TRUE : FALSE);
	t_button = gtk_object_get_data(GTK_OBJECT(cd->pb), "unreadmessages");
	b_button = gtk_object_get_data(GTK_OBJECT(cd->pb), "allmessages");
	if(disp_info->show_all_messages)
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(b_button), TRUE);
	else
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(t_button), TRUE);

	/**** 7-segment/alpha numeric ****/
	b_button = gtk_object_get_data(GTK_OBJECT(cd->pb), "sevensegment");
	t_button = gtk_object_get_data(GTK_OBJECT(cd->pb), "alphanumeric");
	if(disp_info->disptype == DispAlphaNumeric)
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(b_button), TRUE);
	else
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(t_button), TRUE);

	/**** Autorange on/off ****/
	mailbox_s = gtk_object_get_data(GTK_OBJECT(cd->pb), "autorange");
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(mailbox_s), disp_info->autodigits);

	/**** Exec button on/off ****/
	mailbox_s = gtk_object_get_data(GTK_OBJECT(cd->pb), "execbutton");
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(mailbox_s), disp_info->exec_button);

	/**** leading zeros ****/
	mailbox_s = gtk_object_get_data(GTK_OBJECT(cd->pb), "leadingzeros");
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(mailbox_s), disp_info->leading_zeros);

	/**** indicate counting ****/
	mailbox_s = gtk_object_get_data(GTK_OBJECT(cd->pb), "indicatecounting");
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(mailbox_s), disp_info->indicate_counting);

	/**** Number of digits *****/
	mailbox_s = gtk_object_get_data(GTK_OBJECT(cd->pb), "digits");
	sprintf(buffer, "%d", disp_info->digits);
	gtk_widget_set_sensitive(mailbox_s, disp_info->autodigits == 0 ? TRUE : FALSE);
	gtk_entry_set_text(GTK_ENTRY(mailbox_s), buffer);

	/**** Renew timeout for this display *****/
	mailbox_s = gtk_object_get_data(GTK_OBJECT(cd->pb), "update");
	sprintf(buffer, "%d", disp_info->updatetime);
	gtk_entry_set_text(GTK_ENTRY(mailbox_s), buffer);

	/**** Preset for this display *****/
	mailbox_s = gtk_object_get_data(GTK_OBJECT(cd->pb), "preset");
	sprintf(buffer, "%d", disp_info->preset);
	gtk_entry_set_text(GTK_ENTRY(mailbox_s), buffer);

	mailbox_s = gtk_object_get_data(GTK_OBJECT(cd->pb), "countwhat");
	gtk_option_menu_set_history (GTK_OPTION_MENU (mailbox_s), disp_info->count_mode-1);
}

static GtkWidget *
show_display_prefs(CountData *cd, DISP_INFO *disp_info) {
	int i;
	char buffer[40];
	GtkWidget *mail_filename, *mail_table, *radio_table, *entry, *label, *box, *checkbox, *ww, *frame, *t_button, *b_button, *update, *displays2, *omenu, *menu, *item;
	GtkAdjustment *adj;
	int row;

	row = 0;
	i = disp_info->number;
	mail_table = gtk_table_new(11, 3, FALSE);

	/* Title */
	label = gtk_label_new(_("Title"));
	entry = gtk_entry_new();
	gtk_entry_set_text(GTK_ENTRY(entry), (gchar *) disp_info->title);
	sprintf(buffer, "title");
	gtk_object_set_data(GTK_OBJECT(cd->pb), buffer, entry);
	gtk_table_attach_defaults(GTK_TABLE(mail_table), label, 0, 1, row, row+1);
	gtk_table_attach_defaults(GTK_TABLE(mail_table), entry,  1, 3, row, row+1);
	row++;
	gtk_signal_connect(GTK_OBJECT(entry), "changed",
		   GTK_SIGNAL_FUNC(changed_cb), cd);

	/* Mode */
	label = gtk_label_new(_("Mode"));
	frame = gtk_hbox_new (FALSE, 0);
	gtk_table_attach_defaults(GTK_TABLE(mail_table), label, 0, 1, row, row+1);
	gtk_table_attach_defaults(GTK_TABLE(mail_table), frame, 1, 2, row, row+1);
	row++;
	radio_table = gtk_table_new(1, 2, TRUE);
//	gtk_container_add (GTK_CONTAINER (frame), radio_table);
  omenu = gtk_option_menu_new ();
	menu = gtk_menu_new ();
	sprintf(buffer, "countwhat");
	gtk_object_set_data(GTK_OBJECT(cd->pb), buffer, omenu);
	item = gtk_menu_item_new_with_label(_("Mailbox"));
	gtk_menu_append (GTK_MENU (menu), item);
	gtk_signal_connect(GTK_OBJECT(item), "activate",
		   GTK_SIGNAL_FUNC(set_mailbox_mode), cd);
	item = gtk_menu_item_new_with_label(_("IMAP"));
	gtk_menu_append (GTK_MENU (menu), item);
	gtk_signal_connect(GTK_OBJECT(item), "activate",
		   GTK_SIGNAL_FUNC(set_imap_mode), cd);
	item = gtk_menu_item_new_with_label(_("Command"));
	gtk_menu_append (GTK_MENU (menu), item);
	gtk_signal_connect(GTK_OBJECT(item), "activate",
		   GTK_SIGNAL_FUNC(set_command_mode), cd);
	gtk_option_menu_set_menu (GTK_OPTION_MENU (omenu), menu);
	gtk_container_add (GTK_CONTAINER (frame), omenu);
	gtk_widget_show (omenu);

	t_button = gtk_radio_button_new_with_label (NULL, _("Mail"));
	sprintf(buffer, "mailmode_on");
	gtk_object_set_data(GTK_OBJECT(cd->pb), buffer, t_button);
	gtk_table_attach(GTK_TABLE(radio_table), t_button, 0, 1, 0, 1,
       GTK_FILL | GTK_SHRINK, GTK_EXPAND | GTK_SHRINK, 0, 0);
	b_button = gtk_radio_button_new_with_label (gtk_radio_button_group (GTK_RADIO_BUTTON (t_button)), _("Command"));
	sprintf(buffer, "mailmode_off");
	gtk_object_set_data(GTK_OBJECT(cd->pb), buffer, b_button);
	gtk_table_attach(GTK_TABLE(radio_table), b_button, 1, 2, 0, 1,
       GTK_FILL | GTK_SHRINK, GTK_EXPAND | GTK_SHRINK, 0, 0);
	if(disp_info->count_mode)
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(t_button), TRUE);
	else
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(b_button), TRUE);
	gtk_signal_connect(GTK_OBJECT(t_button), "toggled",
		   GTK_SIGNAL_FUNC(toggle_countmode), cd);

	/* Mailbox */
	label = gtk_label_new(_("Mailbox"));
	box = gtk_hbox_new(FALSE,GNOME_PAD_SMALL);
	sprintf(buffer, "mailboxbox");
	gtk_object_set_data(GTK_OBJECT(cd->pb), buffer, box);
	ww = gnome_file_entry_new("execute",_("Browse"));
	gtk_box_pack_start(GTK_BOX(box),ww,TRUE,TRUE,0);
	mail_filename = gnome_file_entry_gtk_entry (GNOME_FILE_ENTRY (ww));
	gtk_entry_set_text(GTK_ENTRY(mail_filename), (gchar *) disp_info->mailbox_file);
	sprintf(buffer, "mailbox");
	gtk_object_set_data(GTK_OBJECT(cd->pb), buffer, mail_filename);
	gtk_widget_set_sensitive(GTK_WIDGET(box), disp_info->count_mode == MODE_COMMAND ? FALSE : TRUE);
	gtk_table_attach_defaults(GTK_TABLE(mail_table), label, 0, 1, row, row+1);
	gtk_table_attach_defaults(GTK_TABLE(mail_table), box,  1, 3, row, row+1);
	row++;
	gtk_signal_connect(GTK_OBJECT(mail_filename), "changed",
		   GTK_SIGNAL_FUNC(changed_cb), cd);

	/* IMAP Server */
	label = gtk_label_new(_("IMAP Server"));
	box = gtk_hbox_new(FALSE,GNOME_PAD_SMALL);
	sprintf(buffer, "imapserverbox");
	gtk_object_set_data(GTK_OBJECT(cd->pb), buffer, box);
	entry = gtk_entry_new();
	gtk_entry_set_text(GTK_ENTRY(entry), (gchar *) disp_info->imap_server);
	sprintf(buffer, "imapserver");
	gtk_object_set_data(GTK_OBJECT(cd->pb), buffer, entry);
	gtk_box_pack_start(GTK_BOX(box),entry,TRUE,TRUE,0);
	gtk_widget_set_sensitive(GTK_WIDGET(entry), disp_info->count_mode == MODE_IMAP? TRUE : FALSE);
	gtk_table_attach_defaults(GTK_TABLE(mail_table), label, 0, 1, row, row+1);
	gtk_table_attach_defaults(GTK_TABLE(mail_table), box,  1, 3, row, row+1);
	row++;
	gtk_signal_connect(GTK_OBJECT(mail_filename), "changed",
		   GTK_SIGNAL_FUNC(changed_cb), cd);

	/* IMAP Username */
	label = gtk_label_new(_("IMAP Username"));
	box = gtk_hbox_new(FALSE,GNOME_PAD_SMALL);
	sprintf(buffer, "imapuserbox");
	gtk_object_set_data(GTK_OBJECT(cd->pb), buffer, box);
	entry = gtk_entry_new();
	gtk_entry_set_text(GTK_ENTRY(entry), (gchar *) disp_info->imap_username);
	sprintf(buffer, "imapusername");
	gtk_object_set_data(GTK_OBJECT(cd->pb), buffer, entry);
	gtk_box_pack_start(GTK_BOX(box),entry,TRUE,TRUE,0);
	gtk_widget_set_sensitive(GTK_WIDGET(entry), disp_info->count_mode == MODE_IMAP? TRUE : FALSE);
	gtk_table_attach_defaults(GTK_TABLE(mail_table), label, 0, 1, row, row+1);
	gtk_table_attach_defaults(GTK_TABLE(mail_table), box,  1, 3, row, row+1);
	row++;
	gtk_signal_connect(GTK_OBJECT(mail_filename), "changed",
		   GTK_SIGNAL_FUNC(changed_cb), cd);

	/* IMAP Password */
	label = gtk_label_new(_("IMAP Password"));
	box = gtk_hbox_new(FALSE,GNOME_PAD_SMALL);
	sprintf(buffer, "imappassbox");
	gtk_object_set_data(GTK_OBJECT(cd->pb), buffer, box);
	entry = gtk_entry_new();
	gtk_entry_set_text(GTK_ENTRY(entry), (gchar *) disp_info->imap_password);
	gtk_entry_set_visibility(GTK_ENTRY(entry), FALSE);
	sprintf(buffer, "imappassname");
	gtk_object_set_data(GTK_OBJECT(cd->pb), buffer, entry);
	gtk_box_pack_start(GTK_BOX(box),entry,TRUE,TRUE,0);
	gtk_widget_set_sensitive(GTK_WIDGET(entry), disp_info->count_mode == MODE_IMAP? TRUE : FALSE);
	gtk_table_attach_defaults(GTK_TABLE(mail_table), label, 0, 1, row, row+1);
	gtk_table_attach_defaults(GTK_TABLE(mail_table), box,  1, 3, row, row+1);
	row++;
	gtk_signal_connect(GTK_OBJECT(mail_filename), "changed",
		   GTK_SIGNAL_FUNC(changed_cb), cd);

	/* Counting */
	label = gtk_label_new(_("Counting"));
	gtk_table_attach_defaults(GTK_TABLE(mail_table), label, 0, 1, row, row+1);
	frame = gtk_hbox_new (FALSE, 0);
	sprintf(buffer, "countmodeframe");
	gtk_object_set_data(GTK_OBJECT(cd->pb), buffer, frame);
	gtk_table_attach_defaults(GTK_TABLE(mail_table), frame, 1, 3, row, row+1);
	row++;
	radio_table = gtk_table_new(1, 2, TRUE);
	gtk_container_add (GTK_CONTAINER (frame), radio_table);
	t_button = gtk_radio_button_new_with_label (NULL, _("Count unread messages"));
	sprintf(buffer, "unreadmessages");
	gtk_object_set_data(GTK_OBJECT(cd->pb), buffer, t_button);
	gtk_table_attach(GTK_TABLE(radio_table), t_button, 0, 1, 0, 1,
       GTK_FILL | GTK_SHRINK, GTK_EXPAND | GTK_SHRINK, 0, 0);
	b_button = gtk_radio_button_new_with_label (gtk_radio_button_group (GTK_RADIO_BUTTON (t_button)), _("Count all messages"));
	sprintf(buffer, "allmessages");
	gtk_object_set_data(GTK_OBJECT(cd->pb), buffer, b_button);
	gtk_table_attach(GTK_TABLE(radio_table), b_button, 1, 2, 0, 1,
       GTK_FILL | GTK_SHRINK, GTK_EXPAND | GTK_SHRINK, 0, 0);
	if(disp_info->show_all_messages)
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(b_button), TRUE);
	else
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(t_button), TRUE);
	gtk_signal_connect(GTK_OBJECT(t_button), "toggled",
		   GTK_SIGNAL_FUNC(changed_cb), cd);

	/* Execute */
	label = gtk_label_new(_("Execute"));
	entry = gtk_entry_new();
	gtk_entry_set_text(GTK_ENTRY(entry), (gchar *) disp_info->exec_command);
	sprintf(buffer, "exec");
	gtk_object_set_data(GTK_OBJECT(cd->pb), buffer, entry);
	gtk_table_attach_defaults(GTK_TABLE(mail_table), label, 0, 1, row, row+1);
	gtk_table_attach_defaults(GTK_TABLE(mail_table), entry,  1, 3, row, row+1);
	row++;
	gtk_signal_connect(GTK_OBJECT(entry), "changed",
		   GTK_SIGNAL_FUNC(changed_cb), cd);

	/* Count command */
	label = gtk_label_new(_("Count command"));
	entry = gtk_entry_new();
	gtk_entry_set_text(GTK_ENTRY(entry), (gchar *) disp_info->backend_command);
	sprintf(buffer, "backend");
	gtk_object_set_data(GTK_OBJECT(cd->pb), buffer, entry);
	gtk_widget_set_sensitive(GTK_WIDGET(entry), disp_info->count_mode == MODE_COMMAND? TRUE : FALSE);
	gtk_table_attach_defaults(GTK_TABLE(mail_table), label, 0, 1, row, row+1);
	gtk_table_attach_defaults(GTK_TABLE(mail_table), entry,  1, 3, row, row+1);
	row++;
	gtk_signal_connect(GTK_OBJECT(entry), "changed",
		   GTK_SIGNAL_FUNC(changed_cb), cd);

	/* number of digits */
	adj = (GtkAdjustment *) gtk_adjustment_new(disp_info->digits, 1, MAX_DIGITS, 1, 1, 0);
	gtk_adjustment_set_value(adj, disp_info->digits);
	label = gtk_label_new(_("Number of digits"));
	displays2 = gtk_spin_button_new(adj, 0, 0);
	sprintf(buffer, "digits");
	gtk_object_set_data(GTK_OBJECT(cd->pb), buffer, displays2);

	checkbox = gtk_check_button_new_with_label (_("Autorange"));
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbox), disp_info->autodigits);
	gtk_widget_set_sensitive(displays2, disp_info->autodigits == 1 ? FALSE : TRUE);
	sprintf(buffer, "autorange");
	gtk_object_set_data(GTK_OBJECT(cd->pb), buffer, checkbox);
	gtk_table_attach_defaults(GTK_TABLE(mail_table), label, 0, 1, row, row+1);
	gtk_table_attach_defaults(GTK_TABLE(mail_table), displays2,  1, 2, row, row+1);
	gtk_table_attach_defaults(GTK_TABLE(mail_table), checkbox,  2, 3, row, row+1);
	row++;

	gtk_signal_connect(GTK_OBJECT(checkbox), "toggled",
                   	GTK_SIGNAL_FUNC(toggle_autorange), cd);
	gtk_signal_connect(GTK_OBJECT(displays2), "changed",
                   	GTK_SIGNAL_FUNC(changed_cb), cd);
	gtk_signal_connect(GTK_OBJECT(adj), "value_changed",
                   	GTK_SIGNAL_FUNC(changed_cb), cd);

	/* Update */
	adj = (GtkAdjustment *) gtk_adjustment_new(0, 100, 1000000, 1000, 100, 0);
	gtk_adjustment_set_value(adj, disp_info->updatetime);
	label = gtk_label_new(_("Update (ms)"));
	update = gtk_spin_button_new(adj, 0, 0);
	sprintf(buffer, "update");
	gtk_object_set_data(GTK_OBJECT(cd->pb), buffer, update);
	gtk_table_attach_defaults(GTK_TABLE(mail_table), label, 0, 1, row, row+1);
	gtk_table_attach_defaults(GTK_TABLE(mail_table), update,  1, 2, row, row+1);
	row++;
	gtk_signal_connect(GTK_OBJECT(adj), "changed",
                   	GTK_SIGNAL_FUNC(changed_cb), cd);
	gtk_signal_connect(GTK_OBJECT(adj), "value_changed",
                   	GTK_SIGNAL_FUNC(changed_cb), cd);

	/* Exec button */
	label = gtk_label_new(_("Title under counter"));
	gtk_table_attach_defaults(GTK_TABLE(mail_table), label, 0, 1, row, row+1);
	checkbox = gtk_check_button_new_with_label (_("On/Off"));
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbox), disp_info->exec_button);
//		gtk_widget_set_sensitive(displays2, disp_info->autodigits == 1 ? FALSE : TRUE);
	sprintf(buffer, "execbutton");
	gtk_object_set_data(GTK_OBJECT(cd->pb), buffer, checkbox);
	gtk_table_attach_defaults(GTK_TABLE(mail_table), checkbox,  1, 2, row, row+1);
	row++;
	gtk_signal_connect(GTK_OBJECT(checkbox), "toggled",
                   	GTK_SIGNAL_FUNC(changed_cb), cd);

	/* Type of Display (alpha/7-segment) */
	label = gtk_label_new(_("Type of Display"));
	gtk_table_attach_defaults(GTK_TABLE(mail_table), label, 0, 1, row, row+1);
	frame = gtk_hbox_new (FALSE, 0);
	sprintf(buffer, "dispmodeframe");
	gtk_object_set_data(GTK_OBJECT(cd->pb), buffer, frame);
	gtk_table_attach_defaults(GTK_TABLE(mail_table), frame, 1, 3, row, row+1);
	row++;
	radio_table = gtk_table_new(1, 2, TRUE);
	gtk_container_add (GTK_CONTAINER (frame), radio_table);
	t_button = gtk_radio_button_new_with_label (NULL, _("Alpha numeric"));
	sprintf(buffer, "alphanumeric");
	gtk_object_set_data(GTK_OBJECT(cd->pb), buffer, t_button);
	gtk_table_attach(GTK_TABLE(radio_table), t_button, 0, 1, 0, 1,
       GTK_FILL | GTK_SHRINK, GTK_EXPAND | GTK_SHRINK, 0, 0);
	b_button = gtk_radio_button_new_with_label (gtk_radio_button_group (GTK_RADIO_BUTTON (t_button)), _("7-Segment"));
	sprintf(buffer, "sevensegment");
	gtk_object_set_data(GTK_OBJECT(cd->pb), buffer, b_button);
	gtk_table_attach(GTK_TABLE(radio_table), b_button, 1, 2, 0, 1,
       GTK_FILL | GTK_SHRINK, GTK_EXPAND | GTK_SHRINK, 0, 0);
	if(disp_info->disptype == DispSevenSegment)
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(b_button), TRUE);
	else
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(t_button), TRUE);
	gtk_signal_connect(GTK_OBJECT(t_button), "toggled",
		   GTK_SIGNAL_FUNC(changed_cb), cd);

	/* Leading zeros */
	label = gtk_label_new(_("Displaymode"));
	gtk_table_attach_defaults(GTK_TABLE(mail_table), label, 0, 1, row, row+1);
	checkbox = gtk_check_button_new_with_label (_("Leading Zeros"));
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbox), disp_info->leading_zeros);
	sprintf(buffer, "leadingzeros");
	gtk_object_set_data(GTK_OBJECT(cd->pb), buffer, checkbox);
	gtk_table_attach_defaults(GTK_TABLE(mail_table), checkbox,  1, 2, row, row+1);
	gtk_signal_connect(GTK_OBJECT(checkbox), "toggled",
                   	GTK_SIGNAL_FUNC(changed_cb), cd);
	checkbox = gtk_check_button_new_with_label (_("Indicate counting"));
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbox), disp_info->leading_zeros);
	sprintf(buffer, "indicatecounting");
	gtk_object_set_data(GTK_OBJECT(cd->pb), buffer, checkbox);
	gtk_table_attach_defaults(GTK_TABLE(mail_table), checkbox,  2, 3, row, row+1);
	row++;
	gtk_signal_connect(GTK_OBJECT(checkbox), "toggled",
                   	GTK_SIGNAL_FUNC(changed_cb), cd);
	row++;

	/* Preset */
	adj = (GtkAdjustment *) gtk_adjustment_new(0, -1000000, 1000000, 1, 100, 1000);
	gtk_adjustment_set_value(adj, disp_info->preset);
	label = gtk_label_new(_("Preset"));
	update = gtk_spin_button_new(adj, 0, 0);
	sprintf(buffer, "preset");
	gtk_object_set_data(GTK_OBJECT(cd->pb), buffer, update);
	gtk_table_attach_defaults(GTK_TABLE(mail_table), label, 0, 1, row, row+1);
	gtk_table_attach_defaults(GTK_TABLE(mail_table), update,  1, 2, row, row+1);
	row++;
	gtk_signal_connect(GTK_OBJECT(adj), "changed",
                   	GTK_SIGNAL_FUNC(changed_cb), cd);
	gtk_signal_connect(GTK_OBJECT(adj), "value_changed",
                   	GTK_SIGNAL_FUNC(changed_cb), cd);

	return(mail_table);
}

static void
populate_list(CountData *cd) {
	DISP_INFO *disp_info;

	disp_info = get_first_disp(cd->displist);
	while(disp_info) {
		gchar *pcs[2];
		char buffer[4];
		gint row;

		sprintf(buffer, "%d", disp_info->number);
		pcs[0] = strdup(buffer);
		pcs[1] = strdup(disp_info->title);
		row = gtk_clist_append(GTK_CLIST(cd->display_clist), pcs);
		gtk_clist_set_row_data(GTK_CLIST(cd->display_clist), row, (void *) disp_info->number);
		disp_info = get_next_disp(cd->displist, disp_info);
	}
}

void
prefs_cb(GtkWidget *w, gpointer p)
{
	GtkWidget *table;
	GtkWidget *label, *heightw, *widthw, *con, *coff, *cover, *update;
	GtkAdjustment *adj;
	int fr, fg, fb;
	CountData *cd = (CountData *) p;

	cd->pb = gnome_property_box_new();
	gtk_window_set_title(GTK_WINDOW(cd->pb), _("Counter Properties"));
	
	table = gtk_table_new(12, 3, TRUE);

	/* On color */
	label = gtk_label_new(_("LED on color"));
	con = gnome_color_picker_new();
	sscanf(cd->con_s, "#%02x%02x%02x", &fr,&fg,&fb );
	gnome_color_picker_set_i8(GNOME_COLOR_PICKER(con),
	                           fr,
	                           fg,
	                           fb,
	                           255);
	gtk_object_set_data(GTK_OBJECT(cd->pb), "con", con);
	gtk_signal_connect(GTK_OBJECT(con), "color_set",
			   GTK_SIGNAL_FUNC(col_changed_cb), (void *) cd);

	gtk_table_attach_defaults(GTK_TABLE(table), label, 0, 2, 0, 1);
	gtk_table_attach_defaults(GTK_TABLE(table), con, 2, 3, 0, 1);

	/* off color */
	label = gtk_label_new(_("LED off color"));
	coff = gnome_color_picker_new();
	sscanf(cd->coff_s, "#%02x%02x%02x", &fr,&fg,&fb );
	gnome_color_picker_set_i8(GNOME_COLOR_PICKER(coff),
	                           fr,
	                           fg,
	                           fb,
	                           255);
	gtk_object_set_data(GTK_OBJECT(cd->pb), "coff", coff);
	gtk_signal_connect(GTK_OBJECT(coff), "color_set",
			   GTK_SIGNAL_FUNC(col_changed_cb), cd);

	gtk_table_attach_defaults(GTK_TABLE(table), label, 0, 2, 1, 2);
	gtk_table_attach_defaults(GTK_TABLE(table), coff,  2, 3, 1, 2);
	
	/* Over color */
	label = gtk_label_new(_("Overflow color"));
	cover = gnome_color_picker_new();
	sscanf(cd->cover_s, "#%02x%02x%02x", &fr,&fg,&fb );
	gnome_color_picker_set_i8(GNOME_COLOR_PICKER(cover),
	                           fr,
	                           fg,
	                           fb,
	                           255);
	gtk_object_set_data(GTK_OBJECT(cd->pb), "cover", cover);
	gtk_signal_connect(GTK_OBJECT(cover), "color_set",
			   GTK_SIGNAL_FUNC(col_changed_cb), cd);

	gtk_table_attach_defaults(GTK_TABLE(table), label, 0, 2, 2, 3);
	gtk_table_attach_defaults(GTK_TABLE(table), cover, 2, 3, 2, 3);

	/* height */
	label = gtk_label_new(_("Digit height"));
	adj = (GtkAdjustment *) gtk_adjustment_new(0, 15, 100, 1, 10, 0);
	gtk_adjustment_set_value(adj, cd->height);
	heightw = gtk_spin_button_new(adj, 0, 0);
	gtk_object_set_data(GTK_OBJECT(cd->pb), "height", heightw);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 0, 2, 3, 4);
	gtk_table_attach_defaults(GTK_TABLE(table), heightw,  2, 3, 3, 4);

	gtk_signal_connect(GTK_OBJECT(heightw), "changed",
			   GTK_SIGNAL_FUNC(changed_cb), cd);

	/* Width */
	label = gtk_label_new(_("Digit width"));
	adj = (GtkAdjustment *) gtk_adjustment_new(0, 15, 100, 1, 10, 0);
	gtk_adjustment_set_value(adj, cd->width);
	widthw = gtk_spin_button_new(adj, 0, 0);
	gtk_object_set_data(GTK_OBJECT(cd->pb), "width", widthw);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 0, 2, 4, 5);
	gtk_table_attach_defaults(GTK_TABLE(table), widthw,  2, 3, 4, 5);

	gtk_signal_connect(GTK_OBJECT(widthw), "changed",
			   GTK_SIGNAL_FUNC(changed_cb), cd);

	/* number of displays */
/*	label = gtk_label_new(_("Number of counters"));
	adj = (GtkAdjustment *) gtk_adjustment_new(0, 1, MAX_DISPLAYS, 1, 1, 0);
	gtk_adjustment_set_value(adj, new_displays);
	displays2 = gtk_spin_button_new(adj, 0, 0);
	gtk_object_set_data(GTK_OBJECT(cd->pb), "displays", displays2);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 0, 2, 5, 6);
	gtk_table_attach_defaults(GTK_TABLE(table), displays2,  2, 3, 5, 6);

	gtk_signal_connect(GTK_OBJECT(displays2), "changed",
	                   GTK_SIGNAL_FUNC(changed_cb), cd);
	gtk_signal_connect(GTK_OBJECT(adj), "value_changed",
	                   GTK_SIGNAL_FUNC(changed_cb), cd);
*/
	/* spacing */
	adj = (GtkAdjustment *) gtk_adjustment_new(0, 0, 100, 1, 10, 0);
	gtk_adjustment_set_value(adj, cd->spacing);
	label = gtk_label_new(_("Space between counters"));
	update = gtk_spin_button_new(adj, 0, 0);
	gtk_object_set_data(GTK_OBJECT(cd->pb), "spacing", update);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 0, 2, 5, 6);
	gtk_table_attach_defaults(GTK_TABLE(table), update,  2, 3, 5, 6);

	gtk_signal_connect(GTK_OBJECT(adj), "changed",
	                   GTK_SIGNAL_FUNC(changed_cb), cd);
	gtk_signal_connect(GTK_OBJECT(adj), "value_changed",
	                   GTK_SIGNAL_FUNC(changed_cb), cd);

	gnome_property_box_append_page(GNOME_PROPERTY_BOX(cd->pb), table,
				       gtk_label_new(_("General")));

  {
	char *nom_cols[2]={"Nr.", "Title"};
	GtkWidget *hpane, *scrolled_window, *table, *up_button, *down_button, *updownbox, *vbox1, *vbox2, *bbox, *separator;
	DISP_INFO *disp_info;

	/* Display Manager */
	hpane = gtk_hpaned_new();
	gtk_paned_handle_size (GTK_PANED (hpane), 10);
	gtk_paned_gutter_size (GTK_PANED (hpane), 10);

	/* List with Display */
	scrolled_window=gtk_scrolled_window_new(NULL,NULL);
	gtk_widget_set_usize(scrolled_window, 110, -1);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolled_window),
	                                  GTK_POLICY_AUTOMATIC,
	                                  GTK_POLICY_AUTOMATIC);

	gtk_container_set_border_width(GTK_CONTAINER(scrolled_window),1);

	cd->display_clist = gtk_clist_new_with_titles(2, nom_cols);
	populate_list(cd);

	gtk_clist_column_titles_active(GTK_CLIST(cd->display_clist));
	gtk_clist_set_shadow_type (GTK_CLIST(cd->display_clist), GTK_SHADOW_IN);
	gtk_clist_set_column_width(GTK_CLIST(cd->display_clist),0,15);
	gtk_signal_connect(GTK_OBJECT(cd->display_clist),"select_row",
            GTK_SIGNAL_FUNC(select_display_clist),cd);
	gtk_container_add(GTK_CONTAINER(scrolled_window),cd->display_clist);

	updownbox = gtk_hbutton_box_new ();
	gtk_button_box_set_layout (GTK_BUTTON_BOX (updownbox), GTK_BUTTONBOX_SPREAD);
	gtk_button_box_set_spacing (GTK_BUTTON_BOX (updownbox), 5);
	gtk_button_box_set_child_size (GTK_BUTTON_BOX (updownbox), 5, -1);
	gtk_container_set_border_width (GTK_CONTAINER (updownbox), 5);

	up_button = gtk_button_new_with_label (_("Up"));
	gtk_container_add (GTK_CONTAINER (updownbox), up_button);
	gtk_signal_connect (GTK_OBJECT (up_button), "clicked",
	                    GTK_SIGNAL_FUNC (up_button_callback), cd);

	down_button = gtk_button_new_with_label (_("Down"));
	gtk_container_add (GTK_CONTAINER (updownbox), down_button);
	gtk_signal_connect (GTK_OBJECT (down_button), "clicked",
	                    GTK_SIGNAL_FUNC (down_button_callback), cd);

	/* Configuration of Displays */
	if(NULL == (disp_info = get_first_disp(cd->displist)))
		;

	table = show_display_prefs(cd, disp_info);
	cd->current_number = disp_info->number;

	separator = gtk_hseparator_new ();
	bbox = gtk_hbutton_box_new ();
	gtk_button_box_set_layout (GTK_BUTTON_BOX (bbox), GTK_BUTTONBOX_SPREAD);
	gtk_button_box_set_spacing (GTK_BUTTON_BOX (bbox), 5);
	gtk_button_box_set_child_size (GTK_BUTTON_BOX (bbox), 5, -1);
	gtk_container_set_border_width (GTK_CONTAINER (bbox), 5);
	
	cd->try_button = gtk_button_new_with_label (_("Set"));
	gtk_widget_set_sensitive (cd->try_button, FALSE);
	gtk_container_add (GTK_CONTAINER (bbox), cd->try_button);
	gtk_signal_connect (GTK_OBJECT (cd->try_button), "clicked",
	                    GTK_SIGNAL_FUNC (try_button_callback), cd);

	cd->delete_button = gtk_button_new_with_label (_("Delete"));
	gtk_container_add (GTK_CONTAINER (bbox), cd->delete_button);
	gtk_signal_connect (GTK_OBJECT (cd->delete_button), "clicked",
	                    GTK_SIGNAL_FUNC (delete_button_callback), cd);

	cd->new_button = gtk_button_new_with_label (_("New"));
	gtk_container_add (GTK_CONTAINER (bbox), cd->new_button);
	gtk_signal_connect (GTK_OBJECT (cd->new_button), "clicked",
	                    GTK_SIGNAL_FUNC (new_button_callback), cd);

	/* Putting pane together */
	vbox1 = gtk_vbox_new(FALSE, GNOME_PAD_SMALL);
	gtk_box_pack_start(GTK_BOX(vbox1),table,TRUE,TRUE,0);
	gtk_box_pack_start(GTK_BOX(vbox1),separator,TRUE,TRUE,0);
	gtk_box_pack_start(GTK_BOX(vbox1),bbox,TRUE,TRUE,0);
	vbox2 = gtk_vbox_new(FALSE, GNOME_PAD_SMALL);
	gtk_box_pack_start(GTK_BOX(vbox2),scrolled_window,TRUE,TRUE,0);
	gtk_box_pack_start(GTK_BOX(vbox2),updownbox,FALSE,TRUE,0);
	gtk_paned_add1(GTK_PANED (hpane), vbox2);
	gtk_paned_add2(GTK_PANED (hpane), vbox1);

	gnome_property_box_append_page(GNOME_PROPERTY_BOX(cd->pb), hpane,
				       gtk_label_new(_("Display Manager")));
  }

	gtk_signal_connect(GTK_OBJECT(cd->pb), "apply",
                           GTK_SIGNAL_FUNC(apply_cb), cd);
	gtk_signal_connect(GTK_OBJECT(cd->pb), "destroy",
                           GTK_SIGNAL_FUNC(destroy_cb), cd);

	gtk_widget_show_all(cd->pb);
	gtk_clist_select_row(GTK_CLIST(cd->display_clist), 0, 1);
}
